import { PromiseOrValue } from "../interfaces";

declare namespace promiseAll {


    interface All {
        /**
         * Takes multiple promises and returns a new promise that is fulfilled
         * when all promises have been resolved or one has been rejected.
         * @param objectOrArray The promise will be fulfilled with a list of results if invoked with an
         * 						array, or an object of results when passed an object (using the same
         * 						keys). If passed neither an object or array it is resolved with an
         * 						undefined value.
         */
        <T>(array: PromiseOrValue<T>[]): PromiseOrValue<T[]>;
        <T>(object: { [name: string]: PromiseOrValue<T> }): PromiseLike<{ [name: string]: T }>;
        (array: PromiseOrValue<any>[]): PromiseOrValue<any[]>;
        (object: { [name: string]: PromiseOrValue<any> }): PromiseLike<{ [name: string]: any }>;
    }
}

declare const promiseAll: promiseAll.All;
export = promiseAll;

